// JavaScript Document
//*******************************************************************************
//	filename   : hw.js
//	description: Calculate overall weight of edited in PSPad html file with linked files
//	created    : 05.10.2006
//	author     : Serge Balance
//
//	You may distribute this script freely, but please keep this header intact.
//*******************************************************************************
var MODULE_NAME  = "WebWeight";
var MODULE_VER   = "0.8";
var MODULE_TITLE = "Web page overall size";
function Init() {
    menuName = "&" + MODULE_NAME;
    subMenu = "&" + "web";
    addMenuItem(menuName, subMenu, "main", "CTRL+ALT+Q");
}

function main() {
var fso = new ActiveXObject("Scripting.FileSystemObject");
var pat = new Array(); //Array of patterns for searching links
pat[0] = new RegExp("<link.*?href\s*=\s*(.*)","ig");
pat[1] = new RegExp("src\s*=\s*(.*)","ig");
pat[2] = new RegExp("background\s*=\s*(.*)","ig");
//pat[3] = new RegExp("href\s*=\s*(.*)","ig"); //not need for pagesize calculations
var names = new Array(); //for controling multiplied links 
var weight = 0;
var fullname;
var	ed = neweditor();
ed.assignActiveEditor();
var fh = fso.GetFile(ed.fileName());
var basepath = fh.ParentFolder; // basepath without final slash!
weight = weight + fh.size; // document itself
var str = ed.text();
log_clear();
var res, substring, i;
for (i in pat) {
	while ((res = pat[i].exec(str)) != null) {
		substring = exurl(RegExp.$1);
		if (!names_control(substring, names)) {
			fullname = basepath + "\\" + substring;		
			log_add(fullname); log_add("\n"); // comment this line for turn off logging
			try {
				fh = fso.GetFile(fullname);
				weight += fh.size;
			}
			catch(e) {
				//echo (e); //Object Error if file not found
				continue;
			}
		}
	}
}
echo("Overall weight of this page is " + weight + " bytes");
}
//======================================= functions =======================
function exurl(sstr) {
	var url;
	if (sstr.match(/^"([^"]*)"/i)) {
		url = RegExp.$1;
	}	else if (sstr.match(/^'([^']*)'/i)) {
		url = RegExp.$1;
	} else {
		(sstr.match(/^([^'">\s]+)/i)) 
		url = RegExp.$1;
	}
// sstr.match(/"([^"]*)"|'([^']*)'|([^'">\s]+)/i); //In JS must be RegExp.lastParen but not working!!!
//	var url = RegExp.$1; //Gives the highest-numbered actually-filled $1, $2, etc. in Perl $+.
	return url;
}
function names_control(name, names) { // count file only once
	var found = false;
	var tst = new String();
	for (tst in names) {
		if (names[tst] == name) {
			found = true;
			break;
		}
	}
	if (!found) {
		names.push(name);
	}
	delete tst;
	return found; //return true if name found in names, false othervise
}
function cwd(fullpath) {// get basepath
	var fso = new ActiveXObject("Scripting.FileSystemObject");
	var file   = fso.GetFile(fullpath);
	var folderName = file.ParentFolder;
	return folderName;
}
function log_clear() { //clear Log-window
	var edlog = neweditor();
	edlog.assignLog();
	edlog.command("ecClearAll");
}
function log_add(outstr) { //add string to Log-window
	var edlog = neweditor();
	edlog.assignLog();
	edlog.appendText(outstr);
}
function log_paste() { //paste clipboard to Log-window
	var edlog = neweditor();
	edlog.assignLog();
//	edlog.selText("\n");
	edlog.command("ecPaste");
}
